--- debcommit	2010-04-20 21:45:18.000000000 +0100
+++ /usr/bin/debcommit	2010-04-20 21:49:34.000000000 +0100
@@ -334,6 +334,7 @@
 }
 
 my $prog=getprog();
+my $extraparams = '';
 if (! defined $changelog) {
     die "debcommit: Could not find a Debian changelog\n";
 }
@@ -370,13 +371,20 @@
     $message="releasing version $version" if ! defined $message;
 }
 if ($edit) {
-    my $modified = 0;
-    ($message, $modified) = edit($message);
-    die "$progname: Commit message not modified / saved; aborting\n" unless $modified;
+    if ($prog eq 'git')
+    {
+	$extraparams = '-e'
+    }
+    else
+    {    
+	my $modified = 0;
+        ($message, $modified) = edit($message);
+	die "$progname: Commit message not modified / saved; aborting\n" unless $modified;
+    }
 }
 
 if (not $confirm or confirm($message)) {
-    commit($message);
+    commit($message, $extraparams);
     tag($version) if $release;
 }
 
@@ -504,6 +512,7 @@
 
 sub commit {
     my $message=shift;
+    my $extraparams=shift;
 
     die "debcommit: can't specify a list of files to commit when using --all\n"
 	if (@files_to_commit and $all);
@@ -514,8 +523,8 @@
 	    @files_to_commit = ("debian");
 	}
 	$action_rc = $diffmode
-	    ? action($prog, "diff", @files_to_commit)
-	    : action($prog, "commit", "-m", $message, @files_to_commit);
+	    ? action($prog, "diff", $extraparams, @files_to_commit)
+	    : action($prog, "commit", "-m", $message, $extraparams, @files_to_commit);
     }
     elsif ($prog eq 'git') {
 	if (! @files_to_commit && $all) {
@@ -528,12 +537,12 @@
 	    }
 	}
 	if ($diffmode) {
-	    $action_rc = action($prog, "diff", @files_to_commit);
+	    $action_rc = action($prog, "diff", $extraparams, @files_to_commit);
 	} else {
 	    if ($all) {
 		@files_to_commit=("-a")
 	    }
-	    $action_rc = action($prog, "commit", "-m", $message, @files_to_commit);
+	    $action_rc = action($prog, "commit", "-m", $message, $extraparams, @files_to_commit);
 	}
     }
     elsif ($prog eq 'tla' || $prog eq 'baz') {
@@ -554,22 +563,22 @@
 	    (($prog eq 'tla') ? '--' : ()),
 	    @files_to_commit,
 	) if @files_to_commit;
-	$action_rc = action($prog, $diffmode ? "diff" : "commit", @args);
+	$action_rc = action($prog, $diffmode ? "diff" : "commit", $extraparams, @args);
     }
     elsif ($prog eq 'bzr') {
 	if ($diffmode) {
-	    $action_rc = action($prog, "diff", @files_to_commit);
+	    $action_rc = action($prog, "diff", $extraparams, @files_to_commit);
 	} else {
 	    my @fixes_arg = bzr_find_fixes($message);
 	    $action_rc = action($prog, "commit", "-m", $message,
-		@fixes_arg, @files_to_commit);
+		@fixes_arg, $extraparams, @files_to_commit);
 	}
     }
     elsif ($prog eq 'darcs') {
 	if ($diffmode) {
-	    $action_rc = action($prog, "diff", @files_to_commit);
+	    $action_rc = action($prog, "diff", $extraparams, @files_to_commit);
 	} else {
-	    $action_rc = action($prog, "record", "-m", $message, "-a", @files_to_commit);
+	    $action_rc = action($prog, "record", "-m", $message, $extraparams, "-a", @files_to_commit);
 	}
     }
     else {
